diff --git a/third_party/rust/quote-0.4.2/src/lib.rs b/third_party/rust/quote-0.4.2/src/lib.rs
new file mode 100644
index 000000000000..7d174343feaf
--- /dev/null
+++ b/third_party/rust/quote-0.4.2/src/lib.rs
@@ -0,0 +1,501 @@
+//! This crate provides the [`quote!`] macro for turning Rust syntax tree data
+//! structures into tokens of source code.
+//!
+//! [`quote!`]: macro.quote.html
+//!
+//! Procedural macros in Rust receive a stream of tokens as input, execute
+//! arbitrary Rust code to determine how to manipulate those tokens, and produce
+//! a stream of tokens to hand back to the compiler to compile into the caller's
+//! crate. Quasi-quoting is a solution to one piece of that -- producing tokens
+//! to return to the compiler.
+//!
+//! The idea of quasi-quoting is that we write *code* that we treat as *data*.
+//! Within the `quote!` macro, we can write what looks like code to our text
+//! editor or IDE. We get all the benefits of the editor's brace matching,
+//! syntax highlighting, indentation, and maybe autocompletion. But rather than
+//! compiling that as code into the current crate, we can treat it as data, pass
+//! it around, mutate it, and eventually hand it back to the compiler as tokens
+//! to compile into the macro caller's crate.
+//!
+//! This crate is motivated by the procedural macro use case, but is a
+//! general-purpose Rust quasi-quoting library and is not specific to procedural
+//! macros.
+//!
+//! *Version requirement: Quote supports any compiler version back to Rust's
+//! very first support for procedural macros in Rust 1.15.0.*
+//!
+//! ```toml
+//! [dependencies]
+//! quote = "0.4"
+//! ```
+//!
+//! ```
+//! #[macro_use]
+//! extern crate quote;
+//! #
+//! # fn main() {}
+//! ```
+//!
+//! # Example
+//!
+//! The following quasi-quoted block of code is something you might find in [a]
+//! procedural macro having to do with data structure serialization. The `#var`
+//! syntax performs interpolation of runtime variables into the quoted tokens.
+//! Check out the documentation of the [`quote!`] macro for more detail about
+//! the syntax. See also the [`quote_spanned!`] macro which is important for
+//! implementing hygienic procedural macros.
+//!
+//! [a]: https://serde.rs/
+//! [`quote_spanned!`]: macro.quote_spanned.html
+//!
+//! ```
+//! # #[macro_use]
+//! # extern crate quote;
+//! #
+//! # fn main() {
+//! #     let generics = "";
+//! #     let where_clause = "";
+//! #     let field_ty = "";
+//! #     let item_ty = "";
+//! #     let path = "";
+//! #     let value = "";
+//! #
+//! let tokens = quote! {
+//!     struct SerializeWith #generics #where_clause {
+//!         value: &'a #field_ty,
+//!         phantom: ::std::marker::PhantomData<#item_ty>,
+//!     }
+//!
+//!     impl #generics serde::Serialize for SerializeWith #generics #where_clause {
+//!         fn serialize<S>(&self, s: &mut S) -> Result<(), S::Error>
+//!             where S: serde::Serializer
+//!         {
+//!             #path(self.value, s)
+//!         }
+//!     }
+//!
+//!     SerializeWith {
+//!         value: #value,
+//!         phantom: ::std::marker::PhantomData::<#item_ty>,
+//!     }
+//! };
+//! #
+//! # }
+//! ```
+//!
+//! ## Recursion limit
+//!
+//! The `quote!` macro relies on deep recursion so some large invocations may
+//! fail with "recursion limit reached" when you compile. If it fails, bump up
+//! the recursion limit by adding `#![recursion_limit = "128"]` to your crate.
+//! An even higher limit may be necessary for especially large invocations.
+
+// Quote types in rustdoc of other crates get linked to here.
+#![doc(html_root_url = "https://docs.rs/quote/0.4.2")]
+
+extern crate proc_macro2;
+extern crate proc_macro;
+
+mod tokens;
+pub use tokens::Tokens;
+
+mod to_tokens;
+pub use to_tokens::ToTokens;
+
+// Not public API.
+#[doc(hidden)]
+pub mod __rt {
+    // Not public API.
+    pub use proc_macro2::*;
+
+    // Not public API.
+    pub fn parse(tokens: &mut ::Tokens, span: Span, s: &str) {
+        let s: TokenStream = s.parse().expect("invalid token stream");
+        tokens.append_all(s.into_iter().map(|mut t| {
+            t.span = span;
+            t
+        }));
+    }
+
+    // Not public API.
+    pub fn append_kind(tokens: &mut ::Tokens, span: Span, kind: TokenNode) {
+        tokens.append(TokenTree {
+            span: span,
+            kind: kind,
+        })
+    }
+}
+
+/// The whole point.
+///
+/// Performs variable interpolation against the input and produces it as
+/// [`Tokens`]. For returning tokens to the compiler in a procedural macro, use
+/// `into()` to build a `TokenStream`.
+///
+/// [`Tokens`]: struct.Tokens.html
+///
+/// # Interpolation
+///
+/// Variable interpolation is done with `#var` (similar to `$var` in
+/// `macro_rules!` macros). This grabs the `var` variable that is currently in
+/// scope and inserts it in that location in the output tokens. The variable
+/// must implement the [`ToTokens`] trait.
+///
+/// [`ToTokens`]: trait.ToTokens.html
+///
+/// Repetition is done using `#(...)*` or `#(...),*` again similar to
+/// `macro_rules!`. This iterates through the elements of any variable
+/// interpolated within the repetition and inserts a copy of the repetition body
+/// for each one. The variables in an interpolation may be anything that
+/// implements `IntoIterator`, including `Vec` or a pre-existing iterator.
+///
+/// - `#(#var)*` — no separators
+/// - `#(#var),*` — the character before the asterisk is used as a separator
+/// - `#( struct #var; )*` — the repetition can contain other tokens
+/// - `#( #k => println!("{}", #v), )*` — even multiple interpolations
+///
+/// # Hygiene
+///
+/// Any interpolated tokens preserve the `Span` information provided by their
+/// `ToTokens` implementation. Tokens that originate within the `quote!`
+/// invocation are spanned with [`Span::def_site()`].
+///
+/// [`Span::def_site()`]: https://docs.rs/proc-macro2/0.2/proc_macro2/struct.Span.html#method.def_site
+///
+/// A different span can be provided through the [`quote_spanned!`] macro.
+///
+/// [`quote_spanned!`]: macro.quote_spanned.html
+///
+/// # Example
+///
+/// ```
+/// extern crate proc_macro;
+///
+/// #[macro_use]
+/// extern crate quote;
+///
+/// use proc_macro::TokenStream;
+///
+/// # const IGNORE_TOKENS: &'static str = stringify! {
+/// #[proc_macro_derive(HeapSize)]
+/// # };
+/// pub fn derive_heap_size(input: TokenStream) -> TokenStream {
+///     // Parse the input and figure out what implementation to generate...
+///     # const IGNORE_TOKENS: &'static str = stringify! {
+///     let name = /* ... */;
+///     let expr = /* ... */;
+///     # };
+///     #
+///     # let name = 0;
+///     # let expr = 0;
+///
+///     let expanded = quote! {
+///         // The generated impl.
+///         impl ::heapsize::HeapSize for #name {
+///             fn heap_size_of_children(&self) -> usize {
+///                 #expr
+///             }
+///         }
+///     };
+///
+///     // Hand the output tokens back to the compiler.
+///     expanded.into()
+/// }
+/// #
+/// # fn main() {}
+/// ```
+#[macro_export]
+macro_rules! quote {
+    ($($tt:tt)*) => (quote_spanned!($crate::__rt::Span::def_site()=> $($tt)*));
+}
+
+/// Same as `quote!`, but applies a given span to all tokens originating within
+/// the macro invocation.
+///
+/// # Syntax
+///
+/// A span expression of type [`Span`], followed by `=>`, followed by the tokens
+/// to quote. The span expression should be brief -- use a variable for anything
+/// more than a few characters. There should be no space before the `=>` token.
+///
+/// [`Span`]: https://docs.rs/proc-macro2/0.2/proc_macro2/struct.Span.html
+///
+/// ```
+/// # #[macro_use]
+/// # extern crate quote;
+/// # extern crate proc_macro2;
+/// #
+/// # use proc_macro2::Span;
+/// #
+/// # fn main() {
+/// # const IGNORE_TOKENS: &'static str = stringify! {
+/// let span = /* ... */;
+/// # };
+/// # let span = Span::call_site();
+/// # let init = 0;
+///
+/// // On one line, use parentheses.
+/// let tokens = quote_spanned!(span=> Box::into_raw(Box::new(#init)));
+///
+/// // On multiple lines, place the span at the top and use braces.
+/// let tokens = quote_spanned! {span=>
+///     Box::into_raw(Box::new(#init))
+/// };
+/// # }
+/// ```
+///
+/// # Hygiene
+///
+/// Any interpolated tokens preserve the `Span` information provided by their
+/// `ToTokens` implementation. Tokens that originate within the `quote_spanned!`
+/// invocation are spanned with the given span argument.
+///
+/// # Example
+///
+/// The following procedural macro code uses `quote_spanned!` to assert that a
+/// particular Rust type implements the [`Sync`] trait so that references can be
+/// safely shared between threads.
+///
+/// [`Sync`]: https://doc.rust-lang.org/std/marker/trait.Sync.html
+///
+/// ```
+/// # #[macro_use]
+/// # extern crate quote;
+/// # extern crate proc_macro2;
+/// #
+/// # use quote::{Tokens, ToTokens};
+/// # use proc_macro2::Span;
+/// #
+/// # struct Type;
+/// #
+/// # impl Type {
+/// #     fn span(&self) -> Span {
+/// #         Span::call_site()
+/// #     }
+/// # }
+/// #
+/// # impl ToTokens for Type {
+/// #     fn to_tokens(&self, _tokens: &mut Tokens) {}
+/// # }
+/// #
+/// # fn main() {
+/// # let ty = Type;
+/// # let def_site = Span::def_site();
+/// #
+/// let ty_span = ty.span().resolved_at(def_site);
+/// let assert_sync = quote_spanned! {ty_span=>
+///     struct _AssertSync where #ty: Sync;
+/// };
+/// # }
+/// ```
+///
+/// If the assertion fails, the user will see an error like the following. The
+/// input span of their type is hightlighted in the error.
+///
+/// ```text
+/// error[E0277]: the trait bound `*const (): std::marker::Sync` is not satisfied
+///   --> src/main.rs:10:21
+///    |
+/// 10 |     static ref PTR: *const () = &();
+///    |                     ^^^^^^^^^ `*const ()` cannot be shared between threads safely
+/// ```
+///
+/// In this example it is important for the where-clause to be spanned with the
+/// line/column information of the user's input type so that error messages are
+/// placed appropriately by the compiler. But it is also incredibly important
+/// that `Sync` resolves at the macro definition site and not the macro call
+/// site. If we resolve `Sync` at the same span that the user's type is going to
+/// be resolved, then they could bypass our check by defining their own trait
+/// named `Sync` that is implemented for their type.
+#[macro_export]
+macro_rules! quote_spanned {
+    ($span:expr=> $($tt:tt)*) => {
+        {
+            let mut _s = $crate::Tokens::new();
+            let _span = $span;
+            quote_each_token!(_s _span $($tt)*);
+            _s
+        }
+    };
+}
+
+// Extract the names of all #metavariables and pass them to the $finish macro.
+//
+// in:   pounded_var_names!(then () a #b c #( #d )* #e)
+// out:  then!(() b d e)
+#[macro_export]
+#[doc(hidden)]
+macro_rules! pounded_var_names {
+    ($finish:ident ($($found:ident)*) # ( $($inner:tt)* ) $($rest:tt)*) => {
+        pounded_var_names!($finish ($($found)*) $($inner)* $($rest)*)
+    };
+
+    ($finish:ident ($($found:ident)*) # [ $($inner:tt)* ] $($rest:tt)*) => {
+        pounded_var_names!($finish ($($found)*) $($inner)* $($rest)*)
+    };
+
+    ($finish:ident ($($found:ident)*) # { $($inner:tt)* } $($rest:tt)*) => {
+        pounded_var_names!($finish ($($found)*) $($inner)* $($rest)*)
+    };
+
+    ($finish:ident ($($found:ident)*) # $first:ident $($rest:tt)*) => {
+        pounded_var_names!($finish ($($found)* $first) $($rest)*)
+    };
+
+    ($finish:ident ($($found:ident)*) ( $($inner:tt)* ) $($rest:tt)*) => {
+        pounded_var_names!($finish ($($found)*) $($inner)* $($rest)*)
+    };
+
+    ($finish:ident ($($found:ident)*) [ $($inner:tt)* ] $($rest:tt)*) => {
+        pounded_var_names!($finish ($($found)*) $($inner)* $($rest)*)
+    };
+
+    ($finish:ident ($($found:ident)*) { $($inner:tt)* } $($rest:tt)*) => {
+        pounded_var_names!($finish ($($found)*) $($inner)* $($rest)*)
+    };
+
+    ($finish:ident ($($found:ident)*) $ignore:tt $($rest:tt)*) => {
+        pounded_var_names!($finish ($($found)*) $($rest)*)
+    };
+
+    ($finish:ident ($($found:ident)*)) => {
+        $finish!(() $($found)*)
+    };
+}
+
+// in:   nested_tuples_pat!(() a b c d e)
+// out:  ((((a b) c) d) e)
+//
+// in:   nested_tuples_pat!(() a)
+// out:  a
+#[macro_export]
+#[doc(hidden)]
+macro_rules! nested_tuples_pat {
+    (()) => {
+        &()
+    };
+
+    (() $first:ident $($rest:ident)*) => {
+        nested_tuples_pat!(($first) $($rest)*)
+    };
+
+    (($pat:pat) $first:ident $($rest:ident)*) => {
+        nested_tuples_pat!((($pat, $first)) $($rest)*)
+    };
+
+    (($done:pat)) => {
+        $done
+    };
+}
+
+// in:   multi_zip_expr!(() a b c d e)
+// out:  a.into_iter().zip(b).zip(c).zip(d).zip(e)
+//
+// in:   multi_zip_iter!(() a)
+// out:  a
+#[macro_export]
+#[doc(hidden)]
+macro_rules! multi_zip_expr {
+    (()) => {
+        &[]
+    };
+
+    (() $single:ident) => {
+        $single
+    };
+
+    (() $first:ident $($rest:ident)*) => {
+        multi_zip_expr!(($first.into_iter()) $($rest)*)
+    };
+
+    (($zips:expr) $first:ident $($rest:ident)*) => {
+        multi_zip_expr!(($zips.zip($first)) $($rest)*)
+    };
+
+    (($done:expr)) => {
+        $done
+    };
+}
+
+#[macro_export]
+#[doc(hidden)]
+macro_rules! quote_each_token {
+    ($tokens:ident $span:ident) => {};
+
+    ($tokens:ident $span:ident # ! $($rest:tt)*) => {
+        quote_each_token!($tokens $span #);
+        quote_each_token!($tokens $span !);
+        quote_each_token!($tokens $span $($rest)*);
+    };
+
+    ($tokens:ident $span:ident # ( $($inner:tt)* ) * $($rest:tt)*) => {
+        for pounded_var_names!(nested_tuples_pat () $($inner)*)
+        in pounded_var_names!(multi_zip_expr () $($inner)*) {
+            quote_each_token!($tokens $span $($inner)*);
+        }
+        quote_each_token!($tokens $span $($rest)*);
+    };
+
+    ($tokens:ident $span:ident # ( $($inner:tt)* ) $sep:tt * $($rest:tt)*) => {
+        for (_i, pounded_var_names!(nested_tuples_pat () $($inner)*))
+        in pounded_var_names!(multi_zip_expr () $($inner)*).into_iter().enumerate() {
+            if _i > 0 {
+                quote_each_token!($tokens $span $sep);
+            }
+            quote_each_token!($tokens $span $($inner)*);
+        }
+        quote_each_token!($tokens $span $($rest)*);
+    };
+
+    ($tokens:ident $span:ident # [ $($inner:tt)* ] $($rest:tt)*) => {
+        quote_each_token!($tokens $span #);
+        $crate::__rt::append_kind(&mut $tokens,
+            $span,
+            $crate::__rt::TokenNode::Group(
+                $crate::__rt::Delimiter::Bracket,
+                quote_spanned!($span=> $($inner)*).into()
+            ));
+        quote_each_token!($tokens $span $($rest)*);
+    };
+
+    ($tokens:ident $span:ident # $first:ident $($rest:tt)*) => {
+        $crate::ToTokens::to_tokens(&$first, &mut $tokens);
+        quote_each_token!($tokens $span $($rest)*);
+    };
+
+    ($tokens:ident $span:ident ( $($first:tt)* ) $($rest:tt)*) => {
+        $crate::__rt::append_kind(&mut $tokens,
+            $span,
+            $crate::__rt::TokenNode::Group(
+                $crate::__rt::Delimiter::Parenthesis,
+                quote_spanned!($span=> $($first)*).into()
+            ));
+        quote_each_token!($tokens $span $($rest)*);
+    };
+
+    ($tokens:ident $span:ident [ $($first:tt)* ] $($rest:tt)*) => {
+        $crate::__rt::append_kind(&mut $tokens,
+            $span,
+            $crate::__rt::TokenNode::Group(
+                $crate::__rt::Delimiter::Bracket,
+                quote_spanned!($span=> $($first)*).into()
+            ));
+        quote_each_token!($tokens $span $($rest)*);
+    };
+
+    ($tokens:ident $span:ident { $($first:tt)* } $($rest:tt)*) => {
+        $crate::__rt::append_kind(&mut $tokens,
+            $span,
+            $crate::__rt::TokenNode::Group(
+                $crate::__rt::Delimiter::Brace,
+                quote_spanned!($span=> $($first)*).into()
+            ));
+        quote_each_token!($tokens $span $($rest)*);
+    };
+
+    ($tokens:ident $span:ident $first:tt $($rest:tt)*) => {
+        // TODO: this seems slow... special case some `:tt` arguments?
+        $crate::__rt::parse(&mut $tokens, $span, stringify!($first));
+        quote_each_token!($tokens $span $($rest)*);
+    };
+}
diff --git a/third_party/rust/quote-0.4.2/src/to_tokens.rs b/third_party/rust/quote-0.4.2/src/to_tokens.rs
new file mode 100644
index 000000000000..277d0a509898
--- /dev/null
+++ b/third_party/rust/quote-0.4.2/src/to_tokens.rs
@@ -0,0 +1,175 @@
+use super::Tokens;
+
+use std::borrow::Cow;
+
+use proc_macro2::{Literal, Span, Term, TokenNode, TokenTree, TokenStream};
+
+fn tt(kind: TokenNode) -> TokenTree {
+    TokenTree {
+        span: Span::def_site(),
+        kind: kind,
+    }
+}
+
+/// Types that can be interpolated inside a [`quote!`] invocation.
+///
+/// [`quote!`]: macro.quote.html
+pub trait ToTokens {
+    /// Write `self` to the given `Tokens`.
+    ///
+    /// Example implementation for a struct representing Rust paths like
+    /// `std::cmp::PartialEq`:
+    ///
+    /// ```
+    /// extern crate quote;
+    /// use quote::{Tokens, ToTokens};
+    ///
+    /// extern crate proc_macro2;
+    /// use proc_macro2::{TokenTree, TokenNode, Spacing, Span};
+    ///
+    /// pub struct Path {
+    ///     pub global: bool,
+    ///     pub segments: Vec<PathSegment>,
+    /// }
+    ///
+    /// impl ToTokens for Path {
+    ///     fn to_tokens(&self, tokens: &mut Tokens) {
+    ///         for (i, segment) in self.segments.iter().enumerate() {
+    ///             if i > 0 || self.global {
+    ///                 // Double colon `::`
+    ///                 tokens.append(TokenTree {
+    ///                     span: Span::def_site(),
+    ///                     kind: TokenNode::Op(':', Spacing::Joint),
+    ///                 });
+    ///                 tokens.append(TokenTree {
+    ///                     span: Span::def_site(),
+    ///                     kind: TokenNode::Op(':', Spacing::Alone),
+    ///                 });
+    ///             }
+    ///             segment.to_tokens(tokens);
+    ///         }
+    ///     }
+    /// }
+    /// #
+    /// # pub struct PathSegment;
+    /// #
+    /// # impl ToTokens for PathSegment {
+    /// #     fn to_tokens(&self, tokens: &mut Tokens) {
+    /// #         unimplemented!()
+    /// #     }
+    /// # }
+    /// #
+    /// # fn main() {}
+    /// ```
+    fn to_tokens(&self, tokens: &mut Tokens);
+
+    /// Convert `self` directly into a `Tokens` object.
+    ///
+    /// This method is implicitly implemented using `to_tokens`, and acts as a
+    /// convenience method for consumers of the `ToTokens` trait.
+    fn into_tokens(self) -> Tokens
+    where
+        Self: Sized,
+    {
+        let mut tokens = Tokens::new();
+        self.to_tokens(&mut tokens);
+        tokens
+    }
+}
+
+impl<'a, T: ?Sized + ToTokens> ToTokens for &'a T {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        (**self).to_tokens(tokens);
+    }
+}
+
+impl<'a, T: ?Sized + ToOwned + ToTokens> ToTokens for Cow<'a, T> {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        (**self).to_tokens(tokens);
+    }
+}
+
+impl<T: ?Sized + ToTokens> ToTokens for Box<T> {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        (**self).to_tokens(tokens);
+    }
+}
+
+impl<T: ToTokens> ToTokens for Option<T> {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        if let Some(ref t) = *self {
+            t.to_tokens(tokens);
+        }
+    }
+}
+
+impl ToTokens for str {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        tokens.append(tt(TokenNode::Literal(Literal::string(self))));
+    }
+}
+
+impl ToTokens for String {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        self.as_str().to_tokens(tokens);
+    }
+}
+
+macro_rules! primitive {
+    ($($t:ident)*) => ($(
+        impl ToTokens for $t {
+            fn to_tokens(&self, tokens: &mut Tokens) {
+                tokens.append(tt(TokenNode::Literal(Literal::$t(*self))));
+            }
+        }
+    )*)
+}
+
+primitive! {
+    i8 i16 i32 i64 isize
+    u8 u16 u32 u64 usize
+    f32 f64
+}
+
+impl ToTokens for char {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        tokens.append(tt(TokenNode::Literal(Literal::character(*self))));
+    }
+}
+
+impl ToTokens for bool {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        let word = if *self { "true" } else { "false" };
+        tokens.append(tt(TokenNode::Term(Term::intern(word))));
+    }
+}
+
+impl ToTokens for Term {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        tokens.append(tt(TokenNode::Term(*self)));
+    }
+}
+
+impl ToTokens for Literal {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        tokens.append(tt(TokenNode::Literal(self.clone())));
+    }
+}
+
+impl ToTokens for TokenNode {
+    fn to_tokens(&self, tokens: &mut Tokens) {
+        tokens.append(tt(self.clone()));
+    }
+}
+
+impl ToTokens for TokenTree {
+    fn to_tokens(&self, dst: &mut Tokens) {
+        dst.append(self.clone());
+    }
+}
+
+impl ToTokens for TokenStream {
+    fn to_tokens(&self, dst: &mut Tokens) {
+        dst.append_all(self.clone().into_iter());
+    }
+}
diff --git a/third_party/rust/quote-0.4.2/src/tokens.rs b/third_party/rust/quote-0.4.2/src/tokens.rs
new file mode 100644
index 000000000000..8fa2e44318e1
--- /dev/null
+++ b/third_party/rust/quote-0.4.2/src/tokens.rs
@@ -0,0 +1,264 @@
+use super::ToTokens;
+use std::fmt::{self, Debug, Display};
+use std::hash::{Hash, Hasher};
+
+use proc_macro;
+use proc_macro2::{TokenStream, TokenTree};
+
+/// Tokens produced by a [`quote!`] invocation.
+///
+/// [`quote!`]: macro.quote.html
+#[derive(Clone, Default)]
+pub struct Tokens {
+    tts: Vec<TokenTree>,
+}
+
+impl Tokens {
+    /// Empty tokens.
+    pub fn new() -> Self {
+        Tokens { tts: Vec::new() }
+    }
+
+    /// For use by `ToTokens` implementations.
+    ///
+    /// Appends the token specified to this list of tokens.
+    pub fn append<U>(&mut self, token: U)
+    where
+        U: Into<TokenTree>,
+    {
+        self.tts.push(token.into());
+    }
+
+    /// For use by `ToTokens` implementations.
+    ///
+    /// ```
+    /// # #[macro_use] extern crate quote;
+    /// # use quote::{Tokens, ToTokens};
+    /// # fn main() {
+    /// struct X;
+    ///
+    /// impl ToTokens for X {
+    ///     fn to_tokens(&self, tokens: &mut Tokens) {
+    ///         tokens.append_all(&[true, false]);
+    ///     }
+    /// }
+    ///
+    /// let tokens = quote!(#X);
+    /// assert_eq!(tokens.to_string(), "true false");
+    /// # }
+    /// ```
+    pub fn append_all<T, I>(&mut self, iter: I)
+    where
+        T: ToTokens,
+        I: IntoIterator<Item = T>,
+    {
+        for token in iter {
+            token.to_tokens(self);
+        }
+    }
+
+    /// For use by `ToTokens` implementations.
+    ///
+    /// Appends all of the items in the iterator `I`, separated by the tokens
+    /// `U`.
+    pub fn append_separated<T, I, U>(&mut self, iter: I, op: U)
+    where
+        T: ToTokens,
+        I: IntoIterator<Item = T>,
+        U: ToTokens,
+    {
+        for (i, token) in iter.into_iter().enumerate() {
+            if i > 0 {
+                op.to_tokens(self);
+            }
+            token.to_tokens(self);
+        }
+    }
+
+    /// For use by `ToTokens` implementations.
+    ///
+    /// Appends all tokens in the iterator `I`, appending `U` after each
+    /// element, including after the last element of the iterator.
+    pub fn append_terminated<T, I, U>(&mut self, iter: I, term: U)
+    where
+        T: ToTokens,
+        I: IntoIterator<Item = T>,
+        U: ToTokens,
+    {
+        for token in iter {
+            token.to_tokens(self);
+            term.to_tokens(self);
+        }
+    }
+}
+
+impl ToTokens for Tokens {
+    fn to_tokens(&self, dst: &mut Tokens) {
+        dst.tts.extend(self.tts.iter().cloned());
+    }
+
+    fn into_tokens(self) -> Tokens {
+        self
+    }
+}
+
+impl From<Tokens> for TokenStream {
+    fn from(tokens: Tokens) -> TokenStream {
+        tokens.tts.into_iter().collect()
+    }
+}
+
+impl From<Tokens> for proc_macro::TokenStream {
+    fn from(tokens: Tokens) -> proc_macro::TokenStream {
+        TokenStream::from(tokens).into()
+    }
+}
+
+/// Allows a `Tokens` to be passed to `Tokens::append_all`.
+impl IntoIterator for Tokens {
+    type Item = TokenTree;
+    type IntoIter = private::IntoIter;
+
+    fn into_iter(self) -> Self::IntoIter {
+        private::into_iter(self.tts.into_iter())
+    }
+}
+
+mod private {
+    use std::vec;
+    use proc_macro2::TokenTree;
+
+    pub struct IntoIter(vec::IntoIter<TokenTree>);
+
+    pub fn into_iter(tts: vec::IntoIter<TokenTree>) -> IntoIter {
+        IntoIter(tts)
+    }
+
+    impl Iterator for IntoIter {
+        type Item = TokenTree;
+
+        fn next(&mut self) -> Option<Self::Item> {
+            self.0.next()
+        }
+    }
+}
+
+impl Display for Tokens {
+    fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
+        Display::fmt(&TokenStream::from(self.clone()), formatter)
+    }
+}
+
+impl Debug for Tokens {
+    fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
+        struct DebugAsDisplay<'a, T: 'a>(&'a T);
+
+        impl<'a, T> Debug for DebugAsDisplay<'a, T>
+        where
+            T: Display,
+        {
+            fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
+                Display::fmt(self.0, formatter)
+            }
+        }
+
+        formatter
+            .debug_tuple("Tokens")
+            .field(&DebugAsDisplay(self))
+            .finish()
+    }
+}
+
+fn tt_eq(a: &TokenTree, b: &TokenTree) -> bool {
+    use proc_macro2::{TokenNode, Delimiter, Spacing};
+
+    match (&a.kind, &b.kind) {
+        (&TokenNode::Group(d1, ref s1), &TokenNode::Group(d2, ref s2)) => {
+            match (d1, d2) {
+                (Delimiter::Parenthesis, Delimiter::Parenthesis)
+                | (Delimiter::Brace, Delimiter::Brace)
+                | (Delimiter::Bracket, Delimiter::Bracket)
+                | (Delimiter::None, Delimiter::None) => {}
+                _ => return false,
+            }
+
+            let s1 = s1.clone().into_iter();
+            let mut s2 = s2.clone().into_iter();
+
+            for item1 in s1 {
+                let item2 = match s2.next() {
+                    Some(item) => item,
+                    None => return false,
+                };
+                if !tt_eq(&item1, &item2) {
+                    return false;
+                }
+            }
+            s2.next().is_none()
+        }
+        (&TokenNode::Op(o1, k1), &TokenNode::Op(o2, k2)) => {
+            o1 == o2 && match (k1, k2) {
+                (Spacing::Alone, Spacing::Alone) | (Spacing::Joint, Spacing::Joint) => true,
+                _ => false,
+            }
+        }
+        (&TokenNode::Literal(ref l1), &TokenNode::Literal(ref l2)) => {
+            l1.to_string() == l2.to_string()
+        }
+        (&TokenNode::Term(ref s1), &TokenNode::Term(ref s2)) => s1.as_str() == s2.as_str(),
+        _ => false,
+    }
+}
+
+impl PartialEq for Tokens {
+    fn eq(&self, other: &Self) -> bool {
+        if self.tts.len() != other.tts.len() {
+            return false;
+        }
+
+        self.tts
+            .iter()
+            .zip(other.tts.iter())
+            .all(|(a, b)| tt_eq(a, b))
+    }
+}
+
+fn tt_hash<H: Hasher>(tt: &TokenTree, h: &mut H) {
+    use proc_macro2::{TokenNode, Delimiter, Spacing};
+
+    match tt.kind {
+        TokenNode::Group(delim, ref stream) => {
+            0u8.hash(h);
+            match delim {
+                Delimiter::Parenthesis => 0u8.hash(h),
+                Delimiter::Brace => 1u8.hash(h),
+                Delimiter::Bracket => 2u8.hash(h),
+                Delimiter::None => 3u8.hash(h),
+            }
+
+            for item in stream.clone() {
+                tt_hash(&item, h);
+            }
+            0xffu8.hash(h); // terminator w/ a variant we don't normally hash
+        }
+        TokenNode::Op(op, kind) => {
+            1u8.hash(h);
+            op.hash(h);
+            match kind {
+                Spacing::Alone => 0u8.hash(h),
+                Spacing::Joint => 1u8.hash(h),
+            }
+        }
+        TokenNode::Literal(ref lit) => (2u8, lit.to_string()).hash(h),
+        TokenNode::Term(ref word) => (3u8, word.as_str()).hash(h),
+    }
+}
+
+impl<'a> Hash for Tokens {
+    fn hash<H: Hasher>(&self, h: &mut H) {
+        self.tts.len().hash(h);
+        for tt in &self.tts {
+            tt_hash(&tt, h);
+        }
+    }
+}
